/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_CONNTOOL_H
#define GRAPHIC_CONNTOOL_H

#include "tool.h"

class Dialog;
class Graphic;
class Line;
class Menu;
class PopupWindow;
class SlidingLine;
class SlidingRect;
class Window;

//
//
//

class ConnectTool: public Tool
{
	public:
		ConnectTool(GraphicMaster *);
		virtual ~ConnectTool();

		virtual boolean grasp(const Event &);
		virtual boolean manipulating(const Event &);
		virtual boolean effect(const Event &);

		virtual ClassId get_classid() const;
		virtual boolean is_a(ClassId) const;
	protected:
		boolean connection(Graphic *&,Graphic *&) const; // inline
		boolean line(Coord &,Coord &,Coord &,Coord &) const; // inline
	private:
		Coord _fromx,_fromy;
		Coord _tox,_toy;
		Graphic *_g1,*_g2;
		SlidingLine *_sll;
};

inline boolean ConnectTool::connection(Graphic *&from,Graphic *&to) const
{
	from=_g1;
	to=_g2;
	return _g1!=nil && _g2!=nil;
}

inline boolean ConnectTool::line(Coord &from_x,Coord &from_y,Coord &to_x,Coord &to_y) const
{
	from_x=_fromx;
	from_y=_fromy;
	to_x=_tox;
	to_y=_toy;
	return _g1!=nil && _g2!=nil;
}

#endif
