/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_TOOL_H
#define GRAPHIC_TOOL_H

#include "classes.h"

#include <InterViews/coord.h>
#include <InterViews/resource.h>

class Event;
class GraphicList;
class GraphicMaster;

class Tool: public Resource
{
	public:
		virtual ~Tool();

		virtual boolean grasp(const Event &) = 0;
		virtual boolean manipulating(const Event &) = 0;
		virtual boolean effect(const Event &) = 0;

		virtual boolean button_used(unsigned);

		GraphicMaster *graphic_master(); // inline
		void graphic_master(GraphicMaster *);

		virtual ClassId get_classid() const;
		virtual boolean is_a(ClassId) const;
	protected:
		Tool(GraphicMaster *);
	private:
		GraphicMaster *_gm;
};

inline GraphicMaster *Tool::graphic_master()
{
	return _gm;
}

#endif
